伪Acmer的推理(dfs/bfs)

时间限制:1000MS  内存限制:65535K
提交次数:12 通过次数:9

收入:32

题型: 编程题   语言: C++;C

Description

现在正是期末,在复习离散数学的Acmer遇到了问题,你能帮助他吗?
Acmer正在复习的是推理,不过他的推理系统可能与别人的不一样。
(所以说他是一个伪Acmer~。做完这题,请自觉把这里伪Acmer自己定义的概念忘了。。否则到时学离散的时候混淆了概念的话自重。。。)
他的推理系统定义如下:
1.用大写英文字母A-Z表示一个命题。
2.用A→B表示若命题A成立则命题B成立。
3.用A↔B表示A→B且B→A。
(这里2,3皆表示一种逻辑关系。)
推理就是由若干个命题或逻辑关系出发,推出新的命题或逻辑关系。
如,已知A→B和B→C,我们可以推出A→C。
又如,已知A→B和A,我们可以推出B。
再如,如果仅有A、B成立,是不可以推出A→B的。
。。。。。。
现在Acmer已经知道了n个命题或逻辑关系是成立的。而且,他从这些前提出发,又推出了m个新的命题或逻辑关系出来。
不过,他的推理过程并不一定正确。所以,你能告诉他这m个结论中哪些是正确的,哪些是错误的吗?

输入格式

单case输入。
第一行是一个整数n(0<=n<=100)。
接下来n行,每行表示1个已知成立的命题或逻辑关系。
每行首先是一个数字x(1<=x<=3),
  若是1,后面接一个大写英文字母,表示一个命题。
  若是2,后面接两个大写英文字母,表示逻辑关系→。
  若是3,后面接两个大写英文字母,表示逻辑关系↔。
接着是一个整数m(0 < m <= 100)。
接下来m行,每行表示1个要求判断正误的命题或逻辑关系。
每行的格式同上。

输出格式

输出m行。对每个要你判断的结论,正确的话输出“yes”,否则输出“no”。

输入样例

Sample#1:
2
2	A 	B
2	B	C
1
2	A	C

Sample#2:
1
2	A	B
1
1	B

Sample#3:
2
2	A	B
1	A
1
1	B

输出样例

Sample#1:
yes

Sample#2:
no

Sample#3:
yes

提示

Sample#不是输入输出的一部分。
注意区别命题和逻辑关系成立的不同。

思路:直接dfs暴力搜一遍,被坑了一下(花了1积分)囧  例子:013    Z    Z答案应该是 yes

/*time  memy
  31ms  3854k
  by orc
  2015 4 16
  */
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;
int vis[30], vis2[30];
int n, x;
int t;
char u, v, k;
vector<int> G[30];
void read_graph()
{
    cin >> n;
    memset(vis,0,sizeof vis );
    for(int i = 0; i < n; ++i)
    {
        cin >> t;
        if(t == 1) { cin >> k; vis[k - ‘A‘] = 1; continue; }//单个点直接标记为成立
        else if(t == 2) {  cin >> u >> v; G[u-‘A‘].push_back(v - ‘A‘); }
        else {  cin >> u >> v; G[u-‘A‘].push_back(v - ‘A‘); G[v - ‘A‘].push_back(u - ‘A‘); }
    }
}
void dfs_pre(int m)
{
    vis[m] = 1;
    int num = G[m].size();
    for(int i = 0; i < num; ++i)
    if(! vis[ G[m][i] ]) dfs_pre(G[m][i]);
}
int dfs(int m,int tag)
{
    int i;
    vis2[m] = 1;
    if(m == tag) return 1;
    int num = G[m].size();
    for(i = 0; i < num ; ++i)
    if(! vis2[ G[m][i] ] )  { if(dfs(G[m][i],tag)) return 1; }
    if(i >= num ) return 0;
}
void solve()
{
    int i;
    read_graph();
    for(i=0 ;i < 26 ; ++i)//扫一遍,若某结点之前标记了,其邻接点也是成立的
    if(vis[i]) dfs_pre(i);
    cin >> x;
    while(x --)
    {
        cin >> t;
        if(t == 1) {
            cin >> k;
        if(vis[k - ‘A‘]) cout << "yes" <<endl;
        else cout << "no" <<endl;
        continue;
        }
        if(t == 2){
            memset(vis2, 0 ,sizeof vis2 );
            cin >> u >> v;
            if(u == v) { cout << "yes" <<endl; continue; }//特判
            int num = G[u - ‘A‘].size();
            for(i = 0; i < num; ++i)
            if(! vis2[ G[u - ‘A‘][i] ]) { if(dfs(G[u - ‘A‘][i],v - ‘A‘)) break; }
            if(i >= num) cout << "no" <<endl;
            else cout << "yes" <<endl;
        }
        else{
            memset(vis2, 0 ,sizeof vis2 );
            cin >> u >> v;
            if(u == v) { cout << "yes" <<endl; continue; }//特判
            int leap , leap2;
            int num, num2;
            leap = leap2 = 0;
            num = G[u - ‘A‘].size();
            num2 = G[v - ‘A‘].size();
            for(i = 0; i < num; ++i)//从 u->v  扫一遍u的邻接点
            if(! vis2[ G[u - ‘A‘][i] ]) { if(leap = dfs(G[u - ‘A‘][i],v - ‘A‘)) break; }
            memset(vis2 ,0 ,sizeof vis2);
            for(i = 0; i< num2 ; ++i)//从 v->u 扫一遍v的邻接点
            if(! vis2[ G[v - ‘A‘][i] ]) { if(leap2 = dfs(G[v - ‘A‘][i],u - ‘A‘)) break; }
            if(leap && leap2) cout << "yes" <<endl;
            else cout << "no" <<endl;
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    solve();
    return 0;
}
/*坑爹例子
0
1
3    Z    Z
ans:yes
*/

时间: 2024-10-12 03:50:14

伪Acmer的推理(dfs/bfs)的相关文章

Dearboy&#39;s Puzzle (poj 2308 搜索 dfs+bfs)

Language: Default Dearboy's Puzzle Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 1202   Accepted: 208 Description Dearboy is a game lover. Recently, he loves playing the game Lian Lian Kan. This game is played on a board with N*M grids

FZU1205/SDUT1157_小鼠迷宫问题(DFS+BFS)

解题报告 http://blog.csdn.net/juncoder/article/details/38146041 题目传送门 题意 求最短路和最短路的路数. 思路: BFS+DFS,先求出最短路.在DFS搜等于最短路的条数. 不加优化SDUTOJ过了,数据就是水. 确定了最短路的长度,加上奇偶剪枝FOJ也过了. #include <queue> #include <cmath> #include <cstdio> #include <cstring>

poj3083——dfs+bfs综合题

POJ 3083   dfs+bfs+模拟 Children of the Candy Corn Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 10564   Accepted: 4539 Description The cornfield maze is a popular Halloween treat. Visitors are shown the entrance and must wander through

POJ 3083:Children of the Candy Corn(DFS+BFS)

Children of the Candy Corn Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 9311 Accepted: 4039 Description The cornfield maze is a popular Halloween treat. Visitors are shown the entrance and must wander through the maze facing zombies, ch

HDU 4771 (DFS+BFS)

Problem Description Harry Potter has some precious. For example, his invisible robe, his wand and his owl. When Hogwarts school is in holiday, Harry Potter has to go back to uncle Vernon's home. But he can't bring his precious with him. As you know,

HDU 4771 Stealing Harry Potter&#39;s Precious dfs+bfs

Stealing Harry Potter's Precious Problem Description Harry Potter has some precious. For example, his invisible robe, his wand and his owl. When Hogwarts school is in holiday, Harry Potter has to go back to uncle Vernon's home. But he can't bring his

【DFS/BFS】NYOJ-58-最少步数(迷宫最短路径问题)

[题目链接:NYOJ-58] 经典的搜索问题,想必这题用广搜的会比较多,所以我首先使的也是广搜,但其实深搜同样也是可以的. 不考虑剪枝的话,两种方法实践消耗相同,但是深搜相比广搜内存低一点. 我想,因为广搜需要的就是队列,所以相比递归队列更耗内存? 当然DFS并不像上图所说,需要用栈,而是运用递归即可. BFS: 因为BFS是要一个接一个的遍历,所以用到了结构体,来保存坐标和当前所走步数 1.每走一步,通过定义的结构体,从队列中提取a(即上一步的坐标.步数(步数每次累加)) 2.在a的基础上进行

DFS/BFS+思维 HDOJ 5325 Crazy Bobo

题目传送门 1 /* 2 题意:给一个树,节点上有权值,问最多能找出多少个点满足在树上是连通的并且按照权值排序后相邻的点 3 在树上的路径权值都小于这两个点 4 DFS/BFS+思维:按照权值的大小,从小的到大的连有向边,搜索最多连接点数即是答案.因为排序后,他们之间的路径, 5 可定都是从当前节点u连过去的,那么都是小于这两个节点的.DFS需手动加栈,BFS类似拓扑排序的思路 6 */ 7 #pragma comment (linker, "/STACK:1024000000,10240000

Dfs/Bfs/记忆化搜索问题 | 问题集合

写在前面 动归和搜索似乎我打得特憋懒. 可能是因为搜索打的太少了??? 然后之前做过的一些题我就不再写了,比如填涂颜色/海战啥的? 然后每一题打两种解法(:Dfs/Bfs 前提是在题目里两种都能A P1596 湖计数 题目描述 Due to recent rains, water has pooled in various places in Farmer John's field, which is represented by a rectangle of N x M (1 <= N <=